import time
import pyui
import pygame


sx = 800
sy = 600

from OpenGL.GL import *
from OpenGL.GLU import *
from OpenGL.GLUT import *

from Numeric import array

CUBE_POINTS = (
    (0.5, -0.5, -0.5),  (0.5, 0.5, -0.5),
    (-0.5, 0.5, -0.5),  (-0.5, -0.5, -0.5),
    (0.5, -0.5, 0.5),   (0.5, 0.5, 0.5),
    (-0.5, -0.5, 0.5),  (-0.5, 0.5, 0.5)
    )

vertices = \
    (0.5, -0.5, -0.5, 0.5, 0.5, -0.5,
     -0.5, 0.5, -0.5, -0.5, -0.5, -0.5,
     0.5, -0.5, 0.5, 0.5, 0.5, 0.5,
    -0.5, -0.5, 0.5, -0.5, 0.5, 0.5
    )


#colors are 0-1 floating values
CUBE_COLORS = (
    (1, 0, 0),          (1, 1, 0),
    (0, 1, 0),          (0, 0, 0),
    (1, 0, 1),          (1, 1, 1),
    (0, 0, 1),          (0, 1, 1)
)

CUBE_QUAD_VERTS = (
    (0, 1, 2, 3), (3, 2, 7, 6), (6, 7, 5, 4),
    (4, 5, 1, 0), (1, 5, 7, 2), (4, 0, 3, 6)
)

CUBE_EDGES = (
    (0,1), (0,3), (0,4), (2,1), (2,3), (2,7),
    (6,3), (6,4), (6,7), (5,1), (5,4), (5,7),
)


all_vertices = (25, 25, 100, 325, 175, 25, 175, 325, 250, 25, 325, 325)
all_indices = ( 4, 5, 6, 7, 1, 2, 6, 5, 0, 1, 5, 4, 0, 3, 2, 1, 0, 4, 7, 3, 2, 3, 7, 6, )



def cubeSetup():
    glMatrixMode(GL_PROJECTION)
    gluPerspective(45.0,640/480.0,0.1,100.0)    #setup lens
    glTranslate(0.0, -0.3, -50.0)                 #move back
    glRotate(25, 1, 0.5, 0)                       #orbit higher

    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL)
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT)
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT)
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST)
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST)

def drawCube():
    
    #glEnable(GL_DEPTH_TEST)
    #glEnable(GL_NORMALIZE)
    #glShadeModel(GL_SMOOTH)

    #allpoints = zip(CUBE_POINTS, CUBE_COLORS)
    
    #glBegin(GL_QUADS)
    #for face in CUBE_QUAD_VERTS:
    #    for vert in face:
    #        pos, color = allpoints[vert]
    #        glColor3(color)
    #        glVertex(pos)
    #glEnd()

    #glColor3((1.0, 1.0, 1.0))
    #glBegin(GL_LINES)
    #for line in CUBE_EDGES:
    #    for vert in line:
    #        pos, color = allpoints[vert]
    #        glVertex(pos)
    #glEnd()

    #pyui.gl.setup2D()
    
    glEnableClientState(GL_VERTEX_ARRAY)

    vstring = ""
    vertices = array( [[50,50,0],[50,100,0],[100,100,0],[100,50,0]] )
    
    indicies = (0,1,2,3)

    glPushClientAttrib(GL_CLIENT_VERTEX_ARRAY_BIT)
    glVertexPointeri(vertices)
    
    glDrawElements(GL_QUADS, GL_UNSIGNED_INT, indicies)

    glPopClientAttrib()

    #pyui.gl.teardown2D()
    
def onbutton(self):
    print "got a button "
    pyui.core.setWaiting(1)
    
def run():
    done = 1
    frame = 0
    last = time.time()
    global sx, sy
    pyui.init(sx, sy)
    w = pyui.widgets.Frame(20, 20, 760, 160, "3D Test Window")
    w.setLayout(pyui.layouts.GridLayoutManager(3,3))
    w.setBackImage("max.bmp")
    b1 = pyui.widgets.Button( "here", onbutton)
    b2 = pyui.widgets.Button( "another", onbutton)
    b3 = pyui.widgets.Button( "Foo", onbutton)    
    b4 = pyui.widgets.Button( "button", onbutton)
    b5 = pyui.widgets.Button( "button", onbutton)
    b6 = pyui.widgets.Label( "Text!")    
    b7 = pyui.widgets.Label( "Text!")
    fps = pyui.widgets.Label("FPS: ")
    
    w.addChild(b1)
    w.addChild(b2)
    w.addChild(b3)
    w.addChild(b4)
    w.addChild(b5)
    w.addChild(b6)
    w.addChild(b7)
    w.addChild(fps)
    
    w.pack()

    cubeSetup()

    while done:
        pyui.draw()
        drawCube()
        glRotate(1, 0, 1, 0)                    
        done = pyui.update()
        pyui.core.setMustFill()

        t = time.time()
        if t > last+1:
            fps.setText("FPS: %d" % frame)
            frame = 0
            last = t
        frame = frame + 1

    print "done"
    pyui.quit()


if __name__ == '__main__':
    run()
